######################################################################
# star.pl - This is PyukiWiki, yet another Wiki clone.
# $Id: star.pl,v 1.359 2012/04/11 21:31:07 papu Exp $
#
# "PyukiWiki" ver 0.2.1-alpha1-dev2 $$
# Author: Hiroshi Yuki http://www.hyuki.com/
# Copyright (C) 2004-2012 Nekyo
# http://nekyo.qp.land.to/
# Copyright (C) 2005-2012 PyukiWiki Developers Team
# http://pyukiwiki.info/
# Based on YukiWiki http://www.hyuki.com/yukiwiki/
# Powerd by PukiWiki http://pukiwiki.sfjp.jp/
# License: GPL3 and/or Artistic or each later version
#
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
# Return:LF Code=UTF-8 1TAB=4Spaces
######################################################################

use strict;

package star;

sub plugin_inline {
	my @args = split(/,/, shift);
	my $max=5;
	my $now=0;
	my $star="&#9733;";

	if(@args >= 2) {
		if($args[1]+0 > 0) {
			$max=$args[1];
		}
	}
	if($args[0]+0 > 0) {
		$now=$args[0];
	}

	my $out;
	for (my $i=1; $i <= $max; $i++) {
		if($i <= $now) {
			$out.=qq(<span style="color: #ddaa44;">$star</span>);
		} else {
			$out.=qq(<span style="color: #666666;">$star</span>);
		}
	}
	return $out;
}

1;
__END__
